<?php
/*
Plugin Name: Unique Visitors
Plugin URI: http://www.richardsramblings.com/plugins/wp-unique-visitors/
Description: This plugin uses a unique ID in a cookie so that you can easily identify anonymous visitors, even if they use dynamic IP addresses.
Author: Richard D. LeCour
Version: 1.01
Author URI: http://www.richardsramblings.com/
*/ 

global $unique_visitor_id;

function unique_visitors_cookie() {
   global $unique_visitor_id;
   $cookie_name = "unique-visitor";
   // CHECK FOR EXISTING COOKIE AND GET ITS UNIQUE ID
   if (!empty($_COOKIE[$cookie_name])) {
      $unique_visitor_id = $_COOKIE[$cookie_name];
   }
   else {
      // GET A UNIQUE ID AND SET IT IN A NEW COOKIE
      $unique_visitor_id = md5(unique_visitors_create_id());
      setcookie($cookie_name, $unique_visitor_id, time() +30000000);
   }
}

function unique_visitors_tracker() {
   global $unique_visitor_id;
   // NOW THAT WE HAVE AN ID, USE IT AS A PARAMETER AFTER AN IMAGE.
   // USING THIS METHOD, YOU CAN ANALYZE YOUR SERVER LOGS TO IDENTIFY VISITORS.
   preg_match("/.wp\-content(.*)$/i", dirname(__FILE__), $matches);
   $image_url = get_bloginfo('home').$matches[0];
   echo '<img src="'.$image_url.'/spacer.gif?'.$unique_visitor_id.'" ';
   echo 'width="1" height="1" border="0" alt="" class="wpuv" />';
}

function get_unique_visitors_id() {
   global $unique_visitor_id;
   return $unique_visitor_id;
}

function unique_visitors_create_id() {
   // GENERATE UNIQUE ID (from http://www.php.net/manual/en/function.uniqid.php#65879)
   return sprintf('%04x%04x-%04x-%03x4-%04x-%04x%04x%04x',
      mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 4095),
      bindec(substr_replace(sprintf('%016b', mt_rand(0, 65535)), '01', 6, 2)),
      mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535)
   ); 
}

add_action('template_redirect', 'unique_visitors_cookie', 10);
add_action('wp_footer', 'unique_visitors_tracker');

?>